//This is an adaptation of a "Hot Example" Quadratic Sieve. The original I couldn't get to work.
//But wanted to include a Tonelli Shanks code block for Acceleration. 
//So persisted as a Quadratic Sieve is very much Continued Fraction based. 
//This implementation give clues as to how to handle the large exponents 
//that impede Tonelli Shanks Algorithm. Adaptation works for required Factors. So worth a crack at ! 
//Having just reviewed the code. I wouldn't copy unless the following issues are resolved
//The initial vector delarations need redoing.
//It probably needs a Container iterator for PAIRS implementation
//Requires Code blocks be put into Class's 
//Properly implement the Quadratic Sieve requires a Linear Gaussian Reduction.
//Large integer use needs standard. 
//As a means to an end worth a crack at, but other Algorithms better, so I leave as is. (It works for small integers) 
//Next Algorithm "Schoof, Elkie, Atkin" with Luna Prime leaps (Gaussian Factorials) 
//
#include <algorithm>
#include <cassert>
#include <cmath>
#include <iostream>
#include <vector>
#include <set>

using namespace std;
typedef unsigned long long int Mi9;
vector<Mi9> primes;
vector<Mi9> Factor_Base_Legendre;
int sieve_interval = 90;

//Aux Code   //Step 1 Tonelli Shanks
int powerMod(int base, int exponent, int modulus) {  //Choose number n at random until (n/p) = -1. Set z = n^q(mod p)
	int result = 1;                                  //function finds pow(base, exponent) % modulus
	base = base % modulus;
	while (exponent > 0) {
		if (exponent % 2 == 1)
			result = (result * base) % modulus;
		exponent = exponent >> 1;                    //shift bit right, equiv divides by 2(1*n)
		base = (base * base) % modulus;
	}
	return result;
}

int gcd(int a, int b) {                              //function finds GCD (co-prime)
	if (b == 0)
		return a;
	else
		return gcd(b, a % b);
}
//Aux Code   //Step 1 

// "Binary_Kronecker symbol (a/b)" ie Legendre = 1
// "x^2 = a(mod p), p an odd prime. If 'quadratic non residual', result = -1.";
// "If 'quadratic residual', result = 1, If b can be divided by a, result = 0. ";
//
int Binary_Kronecker(int a, int b)
{
	int Pal_2s[]{ 0, 1, 0, -1, 0, -1, 0, 1 };// (-1)^((a^2-1)/8) == pal2s[a&7]
	int v = 0;
	int k = 0;
	int r = 0;
	bool correct2{}; // Initialised to zero
	bool proper1{}; // so is false
	//Step 1
	do {
		if ((b % 2) == 0) {
			cout << " 'Legendre': Even....Input 'b' is an odd prime ? " << endl;
			return b;
			break;
		}// proper1 = true; }odd prime? still true if p and q positive odd integer
		if ((b == 0) && (abs(a) != 1)) { return 0; }
		if ((b == 0) && (abs(a) == 1)) { return 0; }

		if (((a % 2) == 0) && ((b % 2) == 0)) { return 0; proper1 = true; } //Terminate Program
		else if ((b % 2) == 0) {
			v += 1;
			b /= 2;
		}
		if ((v % 2) == 0) {
			k = 1;
		}
		else
		{
			k *= Pal_2s[a & 7]; // *=  
		}
		if (b < 0) {
			b = -b;
		}
		if ((b < 0) && (a < 0)) {
			k = -k;
		}
		//Step 3
		if ((b & 1) && (b > 0)) {
			a = a % b;
		}
		//Step 4
		do {
			if ((a == 0) && (b > 1)) {
				return 0;
				proper1 = true;
				correct2 = true;
			}
			if ((a == 0) && (b == 1)) {
				return k;
				proper1 = true;
				correct2 = true;
			}   //Terminate Program
		//Step 5
			v = 0;
			if ((a % 2) == 0) {
				v += 1;
				a = (a / 2);
				if (v & 1) {
					k *= Pal_2s[b & 7];
				}
			}
			//Step 6
			if (((b % 2) == 1) && (a % 2) == 1) {   ///((b & 1) && (a & 1)) {
				r = b - a;
				if (r > 0) {
					if ((a & b & 2) != 0) { k = -k; }
					b = a;
					a = r;
				}
				else {
					a = -r;
				} //Go to Step 4
			}

		} while (correct2 == false);
	} while (proper1 == false);
}

template <typename NumberContainer>
void removeTheNumbers(NumberContainer& Primeans, Mi9 Pristart)
{
	for (auto iter{ Primeans.begin() }; iter != Primeans.end(); )
	{
		if (*iter < Pristart)
		{
			iter = Primeans.erase(iter);
		}
		else
		{
			++iter;
		}
	}
}

vector<Mi9> Prisieve(Mi9 n, Mi9 Pristart)
{
	vector<bool> prime(n + 1, true);

	prime[0] = false;
	prime[1] = false;
	int m = sqrt(n);
	int NumberPrimes1 = 0;

	for (Mi9 p = 2; p <= m; p++)
	{
		if (prime[p])
		{
			// Update all multiples of p
			for (Mi9 i = p * 2; i <= n; i += p)
				prime[i] = false;
		}
	}

	// push all the primes into the vector 
	vector<Mi9> Primeans;
	for (int i = 0; i < n; i++)
		if (prime[i]) {
			Primeans.push_back(i);
		}
	removeTheNumbers(Primeans, Pristart);
	for (auto ip : Primeans) {
		NumberPrimes1 += 1;
		//This code block not required for Quadratic Sieve
	}
	cout << "NumberPrimes1 =" << NumberPrimes1 << endl;
	return Primeans;
}
//  Step 2
void generate_factor_base(Mi9 n, vector<Mi9>& candidates, vector<Mi9> Factor_Base_Legendre)
{
	bool debug = true;
	candidates.clear();
	for (int i = 0; i < Factor_Base_Legendre.size(); ++i) {
		Mi9 px = Factor_Base_Legendre[i];
		Mi9 nx = n % px;
		Mi9 npow = (px - 1) / 2;
		Mi9 result = powerMod(nx, npow, px);
		assert(result == 1 || result == px - 1);
		if (result == 1)
			candidates.push_back(i);//prime's index in vector primes
	}
	//	if (debug) {
	//		for (unsigned int i = 0; i < candidates.size(); ++i) {
	//			assert(candidates[i] > 0 && candidates[i] < static_cast<int>(primes.size()));
	//			printf("%d\n", primes[candidates[i]]);
	//		}
	//	}
}
/// Step 3
void generate_sieves(Mi9 num, Mi9 interval, vector<Mi9>& vbase, vector<Mi9> Factor_Base_Legendre, vector<int>& pairs_vselect, vector<int>& pairs_vexp)
{
	int root = sqrt(num);
	vector<int> squares;  //Mi9 unsigned results in underflow
	int interval_M_M = (2 * interval + 1);
	int Neg_interval = 0 - interval;
	int index = 0;
	int Bnum = num;
	int value = 0;
	int squares_v = 0;
	int Vbaser = vbase.size();
	for (int i = 0; i <= (interval_M_M - (Vbaser)); ++i) {
		squares.resize(interval_M_M, 4);
		index += 1;
		value = (root + (i + Neg_interval));
		squares[index] = (value * value - Bnum);
	}
	//here we need to use toneli shanks algo to accelerate the sieve process
	for (unsigned int i = 1; i < Vbaser; ++i) {
		int pindex = vbase[i];
		int px = Factor_Base_Legendre[pindex];
		for (unsigned int j = 1; j < squares.size(); ++j) {
			int vexp_cnt = 0;
			squares_v = squares[j];
			while (squares_v % px == 0) {
				squares_v = squares_v / px;
				vexp_cnt += 1;
			}
			if (vexp_cnt > 0) {
				pairs_vselect.push_back(squares[j]); //store all factorable numbers
				pairs_vexp.push_back(vexp_cnt);
			}
		}
	}
}
//Step 4 "Linear Gaussian Elimination" is required for this step. This code only "GCD" used
Mi9 analysis_Legendre(Mi9 Cnum, vector<Mi9>& candidates, vector<int>& pairs_vselect, vector<int>& pairs_vexp, vector<Mi9> Factor_Base_Legendre)
{
	int prod = 1;
	int root = sqrt(Cnum);
	int Flag1 = 0;
	int Flag2 = 0;
	Mi9 ret = 0;
	vector<int> sel_exps;
	set<Mi9> ret_set;
	int len1 = pairs_vselect.size();
	for (unsigned int i = 0; i < len1; ++i) {
		int prod = 1;
		if (prod == 1) {
			//			int index = pairs_v[i][0];
			prod *= (root - sieve_interval + pairs_vselect[i]);
			prod %= Cnum;
			sel_exps.push_back(prod);
		}
	}
	int prod2 = 1;
	int prod1 = 0;
	int len3 = Factor_Base_Legendre.size();
	for (int k = 0; k < len1; ++k) {
		prod1 = sel_exps[k];
		for (int i = 0; i < len3; ++i) {
			//		assert(sel_exps[i] % 2 == 0);
			prod2 *= pow(Factor_Base_Legendre[i], pairs_vexp[i]); //pow(primes[candidates[i - 1]], sel_exps[i] / 2); <- /2 check exponets
			prod2 %= Cnum;
			Mi9 delta = prod1 > prod2 ? prod1 - prod2 : prod2 - prod1;
			ret = gcd(delta, Cnum);
			ret_set.insert(ret);
		}
	}
	int len_ret = ret_set.size();
	for (auto kr : ret_set) {
		cout << kr << "= factor" << endl;
	}

	return ret;
}
//Step 2
vector<Mi9> quadratic_sieve(Mi9 CNum, vector<Mi9> Factor_Base_Legendre)
{
	vector<Mi9> results;
	vector<Mi9> candidates;
	vector<int> pairs_vselect;
	vector<int> pairs_vexp;
	vector<int> vselect;
	generate_factor_base(CNum, candidates, Factor_Base_Legendre);
	generate_sieves(CNum, sieve_interval, candidates, Factor_Base_Legendre, pairs_vselect, pairs_vexp);
	int ret = analysis_Legendre(CNum, candidates, pairs_vselect, pairs_vexp, Factor_Base_Legendre);
	return candidates;
}

int main()
{
	Mi9 Pristart = 0;
	Mi9 Priend = 60;
	Mi9 CNum = 0;
	cout << "Enter Upper Prime limit for Quadratic Sieve, (Try '90' or '60') " << endl;
	cin >> Priend;
	cout << "Enter Composite Integer for Quadratic Sieve " << endl;
	cin >> CNum;
	vector<Mi9> primes = Prisieve(Priend, Pristart);
	for (auto pip : primes) {
		if (Binary_Kronecker(CNum, pip) == 1) {
			Factor_Base_Legendre.push_back(pip);
		}
	}
	vector<Mi9> primes2 = quadratic_sieve(CNum, Factor_Base_Legendre);
	return 0;
}